// AnimationFactoryDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AnimationFactory.h"
#include "AnimationFactoryDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAnimationFactoryDlg dialog

VOID SC_DEBUG( TCHAR * fmt, ... )
{
	TCHAR pszDebugDumpMessage[ 256 ] = "[QC] ";

	va_list marker;

	va_start( marker, fmt );

	vsprintf( pszDebugDumpMessage + 5, fmt, marker );

	va_end( marker );

	strcat( pszDebugDumpMessage, "\n" );

	OutputDebugString( pszDebugDumpMessage );
}

CAnimationFactoryDlg * g_pAnimationFactoryDlg = NULL;

QRETURN on_no_signal_detected_callback( PVOID pDevice, ULONG nVideoInput, ULONG nAudioInput, PVOID pUserData )
{
	ULONG i = (ULONG)(pUserData);

	g_pAnimationFactoryDlg->m_nDeviceVideoWidths[ i ] = 0;

	g_pAnimationFactoryDlg->m_nDeviceVideoHeights[ i ] = 0;

	g_pAnimationFactoryDlg->m_nDeviceAudioChannels[ i ] = 0;

	g_pAnimationFactoryDlg->m_nDeviceAudioBitsPerSamples[ i ] = 0;

	g_pAnimationFactoryDlg->m_nDeviceAudioSampleFrequencys[ i ] = 0;

	SC_DEBUG( "on_no_signal_detected_callback( %d )", i );

	return QCAP_RT_OK;
}

QRETURN on_no_signal_removed_callback( PVOID pDevice, ULONG nVideoInput, ULONG nAudioInput, PVOID pUserData )
{
	ULONG i = (ULONG)(pUserData);

	g_pAnimationFactoryDlg->m_nDeviceVideoWidths[ i ] = 0;

	g_pAnimationFactoryDlg->m_nDeviceVideoHeights[ i ] = 0;

	g_pAnimationFactoryDlg->m_nDeviceAudioChannels[ i ] = 0;

	g_pAnimationFactoryDlg->m_nDeviceAudioBitsPerSamples[ i ] = 0;

	g_pAnimationFactoryDlg->m_nDeviceAudioSampleFrequencys[ i ] = 0;

	SC_DEBUG( "on_no_signal_removed_callback( %d )", i );

	return QCAP_RT_OK;
}    

QRETURN on_format_changed_callback( PVOID pDevice, ULONG nVideoInput, ULONG nAudioInput, ULONG nVideoWidth, ULONG nVideoHeight, BOOL bVideoIsInterleaved, ULONG nVideoFrameRate, ULONG nAudioChannels, ULONG nAudioBitsPerSample, ULONG nAudioSampleFrequency, PVOID pUserData )
{
	ULONG i = (ULONG)(pUserData);

	g_pAnimationFactoryDlg->m_nDeviceVideoWidths[ i ] = nVideoWidth;

	g_pAnimationFactoryDlg->m_nDeviceVideoHeights[ i ] = nVideoHeight;

	g_pAnimationFactoryDlg->m_nDeviceAudioChannels[ i ] = nAudioChannels;

	g_pAnimationFactoryDlg->m_nDeviceAudioBitsPerSamples[ i ] = nAudioBitsPerSample;

	g_pAnimationFactoryDlg->m_nDeviceAudioSampleFrequencys[ i ] = nAudioSampleFrequency;

	SC_DEBUG( "on_format_changed_callback( %d, %d, %d, %d, %d, %d )", i, nVideoWidth, nVideoHeight, nAudioChannels, nAudioBitsPerSample, nAudioSampleFrequency );

	return QCAP_RT_OK;
}

BYTE * g_p_frame_buffer = NULL;

ULONG  g_n_frame_length = 0;

ULONG  g_n_active_channel = 0;

QRETURN on_video_preview_callback( PVOID pDevice, double dSampleTime, BYTE * pFrameBuffer, ULONG nFrameBufferLen, PVOID pUserData )
{
	ULONG i = (ULONG)(pUserData);
	
	EnterCriticalSection( &g_pAnimationFactoryDlg->m_hShareRecordStateAccessCriticalSection );

	if( i == g_pAnimationFactoryDlg->m_nShareRecordActiveChannel ) {

		if( g_pAnimationFactoryDlg->m_nShareRecordState > 0x00000000 ) {

			if( g_pAnimationFactoryDlg->m_hShareRecordThreadBufferReadyEvent ) {

				g_p_frame_buffer = pFrameBuffer;

				g_n_frame_length = nFrameBufferLen;

				g_n_active_channel = i;

				SetEvent( g_pAnimationFactoryDlg->m_hShareRecordThreadBufferReadyEvent );
			}
		}	
	}
	LeaveCriticalSection( &g_pAnimationFactoryDlg->m_hShareRecordStateAccessCriticalSection );

    return QCAP_RT_OK;
}

QRETURN on_audio_preview_callback( PVOID pDevice, double dSampleTime, BYTE * pFrameBuffer, ULONG nFrameBufferLen, PVOID pUserData )
{
	ULONG i = (ULONG)(pUserData);

	EnterCriticalSection( &g_pAnimationFactoryDlg->m_hShareRecordStateAccessCriticalSection );

	if( i == g_pAnimationFactoryDlg->m_nShareRecordActiveChannel ) {

		if( g_pAnimationFactoryDlg->m_nShareRecordState > 0x00000000 ) {

			QCAP_SET_AUDIO_SHARE_RECORD_UNCOMPRESSION_BUFFER( 0, pFrameBuffer, nFrameBufferLen );
		}	
	}
	LeaveCriticalSection( &g_pAnimationFactoryDlg->m_hShareRecordStateAccessCriticalSection );

    return (QRETURN)(QCAP_RT_SKIP_DISPLAY | QCAP_RT_SKIP_CLONE_DISPLAY);
}

DWORD WINAPI on_process_share_record( LPVOID params )
{
	CAnimationFactoryDlg * pAnimationFactoryDlg = (CAnimationFactoryDlg *)(params);

	HANDLE events[ 2 ] = { pAnimationFactoryDlg->m_hShareRecordThreadStopEvent, 

						   pAnimationFactoryDlg->m_hShareRecordThreadBufferReadyEvent };
	while( TRUE ) {
		
		DWORD returns = WaitForMultipleObjects( 2, events, FALSE, INFINITE );

		if( returns == (WAIT_OBJECT_0) ) { break ; }

		if( returns == (WAIT_OBJECT_0 + 1) ) {

			UINT   iFrameNum = 0;

			BYTE * pClipFrameBuffer = NULL;

			ULONG  nClipFrameBufferLen = 0;

			if( (g_pAnimationFactoryDlg->m_iClipCurrentFrame + 1) < 
				
				(g_pAnimationFactoryDlg->m_nClipFrames) ) {

				QCAP_STEP_ANIMATION_CLIP( g_pAnimationFactoryDlg->m_pClip, &iFrameNum, &pClipFrameBuffer, &nClipFrameBufferLen );

				g_pAnimationFactoryDlg->m_iClipCurrentFrame = iFrameNum;
			}
			if( pClipFrameBuffer ) {

				QCAP_SET_VIDEO_SHARE_RECORD_UNCOMPRESSION_BUFFER( 0, g_pAnimationFactoryDlg->m_nClipColorSpaceType, 
					
																	 g_pAnimationFactoryDlg->m_nClipWidth, 
																	 
																	 g_pAnimationFactoryDlg->m_nClipHeight, 
																	 
																	 pClipFrameBuffer, 
																	 
																	 nClipFrameBufferLen );
			}
			else {

				QCAP_SET_VIDEO_SHARE_RECORD_UNCOMPRESSION_BUFFER( 0, QCAP_COLORSPACE_TYEP_YUY2, 
					
																	 g_pAnimationFactoryDlg->m_nDeviceVideoWidths[ g_n_active_channel ], 
																	 
																	 g_pAnimationFactoryDlg->m_nDeviceVideoHeights[ g_n_active_channel ], 
																	 
																	 g_p_frame_buffer, 
																	 
																	 g_n_frame_length );
			}
		}
	}
	return 0;
}

CAnimationFactoryDlg::CAnimationFactoryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAnimationFactoryDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAnimationFactoryDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAnimationFactoryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAnimationFactoryDlg)
	DDX_Control(pDX, IDC_STATIC_SHARE_WINDOW, m_statShareWindow);
	DDX_Control(pDX, IDC_STATIC_CHANNEL_WINDOW_3, m_statChannelWindow3);
	DDX_Control(pDX, IDC_STATIC_CHANNEL_WINDOW_2, m_statChannelWindow2);
	DDX_Control(pDX, IDC_STATIC_CHANNEL_WINDOW_1, m_statChannelWindow1);
	DDX_Control(pDX, IDC_STATIC_CHANNEL_WINDOW_0, m_statChannelWindow0);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAnimationFactoryDlg, CDialog)
	//{{AFX_MSG_MAP(CAnimationFactoryDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_STATIC_CHANNEL_WINDOW_0, OnClickedChannelWindow0)
	ON_BN_CLICKED(IDC_STATIC_CHANNEL_WINDOW_1, OnClickedChannelWindow1)
	ON_BN_CLICKED(IDC_STATIC_CHANNEL_WINDOW_2, OnClickedChannelWindow2)
	ON_BN_CLICKED(IDC_STATIC_CHANNEL_WINDOW_3, OnClickedChannelWindow3)
	ON_BN_CLICKED(IDC_BUTTON_RECORD, OnButtonRecord)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAnimationFactoryDlg message handlers

extern CAnimationFactoryApp theApp;

void CAnimationFactoryDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	
	// UNINITIALIZE SHARE RECORDING
	//
	OnButtonStop();

	// UNINITIALIZE ANIMATION CLIP
	//
	if( m_pClip ) {

		QCAP_STOP_ANIMATION_CLIP( m_pClip );

		QCAP_DESTROY_ANIMATION_CLIP( m_pClip );

		m_pClip = NULL;
	}

	// UNINITIALIZE DEVICE RESOURCE
	// 
	for( ULONG i = 0 ; i < 4 ; i++ ) {

		if( m_pDevices[ i ] ) {

			QCAP_STOP( m_pDevices[ i ] );

			QCAP_DESTROY( m_pDevices[ i ] );

			m_pDevices[ i ] = NULL;
		}
	}
	DeleteCriticalSection( &m_hShareRecordStateAccessCriticalSection );

	// UNINITIALIZE COM LIBRARY
	// 
	CoUninitialize();
}

BOOL CAnimationFactoryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	// INITIALIZE COM LIBRARY
	// 
	HRESULT hr = CoInitialize( NULL );

	// INITIALIZE DEVICE RESOURCE
	// 
	g_pAnimationFactoryDlg = this;

	for( ULONG i = 0 ; i < 4 ; i++ ) {
		
		m_pDevices[ i ] = NULL;

		m_nDeviceVideoWidths[ i ] = 0;

		m_nDeviceVideoHeights[ i ] = 0;

		m_nDeviceAudioChannels[ i ] = 0;

		m_nDeviceAudioBitsPerSamples[ i ] = 0;

		m_nDeviceAudioSampleFrequencys[ i ] = 0;
	}
	m_pClip = NULL;

	m_iClipCurrentFrame = 0;

	m_nClipFrames = 0;

	m_nClipSprites = 0;

	m_nClipColorSpaceType = 0x00000000;

	m_nClipWidth = 0;

	m_nClipHeight = 0;

	m_nShareRecordActiveChannel = 0;

	m_nShareRecordState = 0x00000000;

	m_hShareRecordThreadStopEvent = NULL;

	m_hShareRecordThreadBufferReadyEvent = NULL;

	m_hShareRecordThread = NULL;

	m_hShareRecordThreadNumber = 0;

	InitializeCriticalSection( &m_hShareRecordStateAccessCriticalSection );

	// INITIALIZE DEVICE RESOURCE
	// 
	QCAP_CREATE( "SA7160 PCI", 0, m_statChannelWindow0.m_hWnd, &m_pDevices[ 0 ], TRUE );

	QCAP_CREATE( "SA7160 PCI", 1, m_statChannelWindow1.m_hWnd, &m_pDevices[ 1 ], TRUE );

	QCAP_CREATE( "SA7160 PCI", 2, m_statChannelWindow2.m_hWnd, &m_pDevices[ 2 ], TRUE );

	QCAP_CREATE( "SA7160 PCI", 3, m_statChannelWindow3.m_hWnd, &m_pDevices[ 3 ], TRUE );

	for( i = 0 ; i < 4 ; i++ ) {

		QCAP_REGISTER_FORMAT_CHANGED_CALLBACK( m_pDevices[ i ], on_format_changed_callback, (PVOID)(i) );

		QCAP_REGISTER_NO_SIGNAL_DETECTED_CALLBACK( m_pDevices[ i ], on_no_signal_detected_callback, (PVOID)(i) );

		QCAP_REGISTER_SIGNAL_REMOVED_CALLBACK( m_pDevices[ i ], on_no_signal_removed_callback, (PVOID)(i) );

		QCAP_REGISTER_VIDEO_PREVIEW_CALLBACK( m_pDevices[ i ], on_video_preview_callback, (PVOID)(i) );

		QCAP_REGISTER_AUDIO_PREVIEW_CALLBACK( m_pDevices[ i ], on_audio_preview_callback, (PVOID)(i) );

		QCAP_RUN( m_pDevices[ i ] );
	}

	// INITIALIZE ANIMATION RESOURCE
	// 
	QCAP_CREATE_ANIMATION_CLIP( "EXAMPLE.FADEOUT.XML", &m_pClip, &m_nClipFrames, &m_nClipSprites, &m_nClipColorSpaceType, &m_nClipWidth, &m_nClipHeight );

	if( m_pClip == NULL ) {

		QCAP_CREATE_ANIMATION_CLIP( "..\\EXAMPLE.FADEOUT.XML", &m_pClip, &m_nClipFrames, &m_nClipSprites, &m_nClipColorSpaceType, &m_nClipWidth, &m_nClipHeight );
	}
	m_iClipCurrentFrame = m_nClipFrames - 1;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAnimationFactoryDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAnimationFactoryDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAnimationFactoryDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAnimationFactoryDlg::OnOK() 
{
	// TODO: Add extra validation here
	
//	CDialog::OnOK();
}

void CAnimationFactoryDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CAnimationFactoryDlg::OnClickedChannelWindow( ULONG nChannel ) 
{
	SC_DEBUG( "OnClickedChannelWindow( %d )", nChannel );

	if( m_nShareRecordActiveChannel == nChannel ) return ;

	if( m_nDeviceVideoWidths[ nChannel ] == 0 ) return ; 

	if( m_nDeviceVideoHeights[ nChannel ] == 0 ) return ; 

	if( (g_pAnimationFactoryDlg->m_iClipCurrentFrame + 1) < (g_pAnimationFactoryDlg->m_nClipFrames) ) { return ; }

	QCAP_SET_ANIMATION_CLIP_SPRITE_SOURCE( m_pClip, 0, m_pDevices[ m_nShareRecordActiveChannel ] );

	QCAP_SET_ANIMATION_CLIP_SPRITE_SOURCE( m_pClip, 1, m_pDevices[ nChannel ] );

	QCAP_STOP_ANIMATION_CLIP( m_pClip );

	QCAP_START_ANIMATION_CLIP( m_pClip );

	Sleep( 30 ); // NEED WAIT SPRITE SOURCE TO BE UPDATED

	EnterCriticalSection( &g_pAnimationFactoryDlg->m_hShareRecordStateAccessCriticalSection );

	m_iClipCurrentFrame = 0;

	m_nShareRecordActiveChannel = nChannel;

	LeaveCriticalSection( &g_pAnimationFactoryDlg->m_hShareRecordStateAccessCriticalSection );
}

void CAnimationFactoryDlg::OnClickedChannelWindow0() 
{
	// TODO: Add your control notification handler code here
	
	OnClickedChannelWindow( 0 );
}

void CAnimationFactoryDlg::OnClickedChannelWindow1() 
{
	// TODO: Add your control notification handler code here
	
	OnClickedChannelWindow( 1 );
}

void CAnimationFactoryDlg::OnClickedChannelWindow2() 
{
	// TODO: Add your control notification handler code here
	
	OnClickedChannelWindow( 2 );
}

void CAnimationFactoryDlg::OnClickedChannelWindow3() 
{
	// TODO: Add your control notification handler code here
	
	OnClickedChannelWindow( 3 );
}

void CAnimationFactoryDlg::OnButtonRecord() 
{
	// TODO: Add your control notification handler code here
	
	m_hShareRecordThreadStopEvent = CreateEvent( NULL, FALSE, FALSE, NULL );

	m_hShareRecordThreadBufferReadyEvent = CreateEvent( NULL, FALSE, FALSE, NULL );

	m_hShareRecordThread = CreateThread( NULL, 0, (LPTHREAD_START_ROUTINE)(on_process_share_record), (LPVOID)(this), 0, &m_hShareRecordThreadNumber );

	QCAP_SET_VIDEO_SHARE_RECORD_PROPERTY( 0, QCAP_ENCODER_TYPE_NVIDIA_CUDA, QCAP_ENCODER_FORMAT_H264, m_nClipColorSpaceType, m_nClipWidth, m_nClipHeight, 60, QCAP_RECORD_MODE_CBR, 8000, 12000000, 60, 0, 0, m_statShareWindow.m_hWnd, TRUE, FALSE );

	QCAP_SET_AUDIO_SHARE_RECORD_PROPERTY( 0, QCAP_ENCODER_TYPE_SOFTWARE, QCAP_ENCODER_FORMAT_AAC, 2, 16, 48000, 100 );

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	QCAP_SET_VIDEO_RECORD_PROPERTY( m_pDevices[ 0 ], 0, QCAP_ENCODER_TYPE_INTEL_MEDIA_SDK, QCAP_ENCODER_FORMAT_H264, QCAP_RECORD_MODE_CBR, 8000, 12000000, 60, 0, 0, QCAP_DOWNSCALE_MODE_OFF );
	
	QCAP_SET_VIDEO_RECORD_PROPERTY( m_pDevices[ 1 ], 0, QCAP_ENCODER_TYPE_INTEL_MEDIA_SDK, QCAP_ENCODER_FORMAT_H264, QCAP_RECORD_MODE_CBR, 8000, 12000000, 60, 0, 0, QCAP_DOWNSCALE_MODE_OFF );
	
	QCAP_SET_VIDEO_RECORD_PROPERTY( m_pDevices[ 2 ], 0, QCAP_ENCODER_TYPE_INTEL_MEDIA_SDK, QCAP_ENCODER_FORMAT_H264, QCAP_RECORD_MODE_CBR, 8000, 12000000, 60, 0, 0, QCAP_DOWNSCALE_MODE_OFF );
	
	QCAP_SET_VIDEO_RECORD_PROPERTY( m_pDevices[ 3 ], 0, QCAP_ENCODER_TYPE_INTEL_MEDIA_SDK, QCAP_ENCODER_FORMAT_H264, QCAP_RECORD_MODE_CBR, 8000, 12000000, 60, 0, 0, QCAP_DOWNSCALE_MODE_OFF );

	QCAP_SET_AUDIO_RECORD_PROPERTY( m_pDevices[ 0 ], 0, QCAP_ENCODER_TYPE_SOFTWARE, QCAP_ENCODER_FORMAT_AAC );

	QCAP_SET_AUDIO_RECORD_PROPERTY( m_pDevices[ 1 ], 0, QCAP_ENCODER_TYPE_SOFTWARE, QCAP_ENCODER_FORMAT_AAC );

	QCAP_SET_AUDIO_RECORD_PROPERTY( m_pDevices[ 2 ], 0, QCAP_ENCODER_TYPE_SOFTWARE, QCAP_ENCODER_FORMAT_AAC );

	QCAP_SET_AUDIO_RECORD_PROPERTY( m_pDevices[ 3 ], 0, QCAP_ENCODER_TYPE_SOFTWARE, QCAP_ENCODER_FORMAT_AAC );

	//////////////////////////////////////////////////////////////////////////////////////////////////////////

	QCAP_START_SHARE_RECORD( 0, "DEMO.MP4" );

	QCAP_START_RECORD( m_pDevices[ 0 ], 0, "CH01.MP4" );

	QCAP_START_RECORD( m_pDevices[ 1 ], 0, "CH02.MP4" );

	QCAP_START_RECORD( m_pDevices[ 2 ], 0, "CH03.MP4" );

	QCAP_START_RECORD( m_pDevices[ 3 ], 0, "CH04.MP4" );

	Sleep( 30 );

	EnterCriticalSection( &m_hShareRecordStateAccessCriticalSection );

	m_nShareRecordState = 0x00000001;

	LeaveCriticalSection( &m_hShareRecordStateAccessCriticalSection );
}

void CAnimationFactoryDlg::OnButtonStop() 
{
	// TODO: Add your control notification handler code here
	
	EnterCriticalSection( &m_hShareRecordStateAccessCriticalSection );

	m_nShareRecordState = 0x00000000;

	LeaveCriticalSection( &m_hShareRecordStateAccessCriticalSection );

	Sleep( 30 );

	{	if( m_hShareRecordThreadStopEvent ) { SetEvent( m_hShareRecordThreadStopEvent ); }

		CLOSE_THREAD( m_hShareRecordThread );

		if( m_hShareRecordThreadStopEvent != NULL ) {

			CloseHandle( m_hShareRecordThreadStopEvent );

			m_hShareRecordThreadStopEvent = NULL;
		}
		if( m_hShareRecordThreadBufferReadyEvent != NULL ) {

			CloseHandle( m_hShareRecordThreadBufferReadyEvent );

			m_hShareRecordThreadBufferReadyEvent = NULL;
		}
	}
	QCAP_STOP_SHARE_RECORD( 0 );

	QCAP_STOP_RECORD( m_pDevices[ 0 ], 0 );

	QCAP_STOP_RECORD( m_pDevices[ 1 ], 0 );

	QCAP_STOP_RECORD( m_pDevices[ 2 ], 0 );

	QCAP_STOP_RECORD( m_pDevices[ 3 ], 0 );
}
